import { world, system } from '@minecraft/server'
import { ActionFormData, ModalFormData } from '@minecraft/server-ui'
import { Admin_Main } from './main_menu'


class Settingss {

    Main_Menu(player) {
        const form = new ActionFormData()
        .title('Admin Settings')
        .body('Edit All Things About This Add-on!\n')
            .button("Home Settings")
        form.show(player).then((data) => {
            if (data.selection === 0) {
                this.HomeSettings(player);
            }
        });
    }

    HomeSettings(player) {
        const HomeLimit = world.getDynamicProperty('HomesLimit'); // Default to 5 if undefined
        const HomesEnabled = world.getDynamicProperty('HomesEnabled'); // Ensure this is a boolean
    
        const form = new ModalFormData()
            .textField("Home's Limit (default is 5)", String(HomeLimit), String(HomeLimit))
            .toggle('Homes Enabled', HomesEnabled);
    
        form.show(player).then((data) => {
            if (data.canceled) return; // Exit if the form was canceled
    
            const inputLimit = parseInt(data.formValues[0]);
    
            // Validate input
            if (isNaN(inputLimit) || inputLimit < 1) {
                player.sendMessage("§cError: Please enter a valid number!");
                return this.HomeSettings(player); // Retry if invalid input
            }
    
            if (inputLimit > 50) {
                player.sendMessage("§cError: Max Homes Are 50!");
                return this.HomeSettings(player); // Retry if input exceeds limit
            }
    
            // Set the new home limit and homes enabled status in dynamic properties
            world.setDynamicProperty('HomesLimit', inputLimit);
            world.setDynamicProperty('HomesEnabled', data.formValues[1]); // Save the toggle status
        });
    }
    
}

export const Settings = new Settingss();




system.runInterval(() => {

    for (const player of world.getAllPlayers()) {
        const Vanish = player.getDynamicProperty('Vanish')
        if (Vanish === true) {
            player.addEffect('invisibility', 2, { showParticles: false })

        }
    }
})