import { world, system } from '@minecraft/server'
import { ActionFormData, ModalFormData } from '@minecraft/server-ui'
import { Admin_Main } from './main_menu'


class Optionss {

    Player_Selector(player) {
        let onlinePlayers = world.getAllPlayers()
        const form = new ActionFormData()
            .title('Player Options')
        for (let Player of onlinePlayers) {
            if (player.hasTag('Owner') || player.hasTag('owner')) {
                form.button(`§d[OWNER]§r ${Player.nameTag}`, 'textures/ui/icon_steve')
            } else if (player.hasTag('Admin') || player.hasTag('admin')) {
                form.button(`§d[Admin]§r ${Player.nameTag}`, 'textures/ui/icon_steve')
            } else if (!player.hasTag('Owner') || !player.hasTag('owner')) {
                form.button(Player.nameTag, 'textures/ui/icon_steve')
            }
        }
        form.show(player).then((data) => {


            if (data.selection < onlinePlayers.length) {
                this.Main_Menu(player, onlinePlayers, data.selection)
            }
        })
    }

    Main_Menu(player, onlinePlayers, index) {
        let Player = onlinePlayers[index]
        const form = new ActionFormData()
            .title(`${Player.name}'s Options`)
            .button('TPA Options')
            .button('Edit Players Tags')
            .button('')
        form.show(player).then((data) => {
            if (data.selection === 0) {
                this.TPAOptions(player, Player)
            }
        })
    }

    TPAOptions(player, Player) {
        const TPABANREASON = Player.getDynamicProperty('TPABANREASON')
        const TPABAN = Player.getDynamicProperty('TPABAN')
        const form = new ModalFormData()
            .toggle('TPA Ban', TPABAN)
        if (TPABAN === undefined || TPABAN === false) {
            form.textField('TPA Ban Reason', 'Reason', 'No Reason')
        } else if (TPABAN === true) {
            form.textField('TPA Ban Reason', 'Reason', TPABANREASON)
        }
        form.show(player).then((data) => {
            if (data.canceled) return;

            //______________FormValue[0]______________\\
            if (data.formValues[0] === true) {
                player.setDynamicProperty("TPABAN", true)

            }
            if (data.formValues[0] === false) {
                player.setDynamicProperty("TPABAN", false)
            }
            Player.setDynamicProperty('TPABANREASON', data.formValues[1])
        })
    }

}
export const Options = new Optionss


