import { world, system } from '@minecraft/server'
import { ActionFormData, ModalFormData } from '@minecraft/server-ui'
import { Admin_Main } from './main_menu'

class Warps_Menus {


    Admin_Warps(player) {
        const form = new ActionFormData()
            .button('Add Warp')
            .button('List Warps')
            .button('Back')
        form.show(player).then((data) => {

            if (data.selection === 0) {
                this.Add_Warp(player)
            }
            if (data.selection === 1) {
                this.List_Warps(player)
            }
            if (data.selection === 2) {
                Admin_Main(player)
            }
        })
    }

    Add_Warp(player) {
        const form = new ModalFormData()
            .textField('Warp Name\n', '')

        form.show(player).then((data) => {
            if (data.canceled) return;
            system.run(() => {
                Objective.GetObjective(player).addScore(JSON.stringify(new Warps({ Name: data.formValues[0], Player_Location: player.location })), 0)
            })
        })

    }

    List_Warps(player) {
        let Datas = Objective.GetData(player)
        const form = new ActionFormData()
        for (let i = 0; i < Datas.length; i++) {
            let Warp = Datas[i]
            form.button(`${Warp.Name}`)
        }
        form.button('Back')
        form.show(player).then((data) => {
            if (data.selection < Datas.length) {
                return this.Warp_INFO(player, Datas, data.selection)
            }
            if (data.selection < Datas.length) {
                this.Admin_Warps(player)
            }
        })
    }

    Warp_INFO(player, Datas, index) {
        let Warp = Datas[index]
        const form = new ActionFormData()
            .title(`${Warp.Name}`)
            .button('Teleport To Warp')
            .button('Delete Warp')
        form.show(player).then((data) => {

            if (data.selection === 0) {
                return player.teleport(Warp.Player_Location)
            }
            if (data.selection === 1) {
                Objective.GetObjective(player).removeParticipant(JSON.stringify(Warp))
            }
        })
    }
}
export const Warp_Menus = new Warps_Menus



class Warps {

    Player_Location = {}

    Name = ""

    constructor(Warps) {
        if (!Warps) return
        Object.assign(this, Warps)
    }

}

class Objectives {

    GetObjective(player) {
        if (!world.scoreboard.getObjective(`Warps`))
            world.scoreboard.addObjective(`Warps`, `Data_Stored`)
        return world.scoreboard.getObjective(`Warps`)
    }


    GetData(player) {
        let Data = []
        for (let participant of this.GetObjective(player).getParticipants()) {
            let data = new Warps(JSON.parse(participant.displayName))
            Data.push(data)
        }
        return Data
    }

}
export const Objective = new Objectives

