import { ActionFormData, MessageFormData } from '@minecraft/server-ui'
import { world, system } from '@minecraft/server'
import { Main } from '../community_panel/main_menu'

//_________________________________/ Database \_________________________________\\

class DataBase {

    AnnouncementTitle = ''

    Announcement = ''

    constructor(DataBase) {
        if (!DataBase) return
        Object.assign(this, DataBase)
    }

}

class Objectives {

    GetObjective(player) {
        if (!world.scoreboard.getObjective(`Announcement_DataStorage`))
            world.scoreboard.addObjective(`Announcement_DataStorage`, `Data_Stored`)
        return world.scoreboard.getObjective(`Announcement_DataStorage`)
    }


    GetData(player) {
        let Data = []
        for (let participant of this.GetObjective(player).getParticipants()) {
            let data = new DataBase(JSON.parse(participant.displayName))
            Data.push(data)
        }
        return Data
    }

}
export const Objective = new Objectives

//_________________________________/ Other Stuff \_________________________________\\

export function AnnouncementSelection(player) {
    let Datas = Objective.GetData(player)
    const form = new ActionFormData()
    form.title('Announcements!')
    for (let i = 0; i < Datas.length; i++) {
        let Data = Datas[i]
        form.button(`${Data.AnnouncementTitle}`)
    }
    form.button('Back')
    form.show(player).then((data) => {
        if (data.selection < Datas.length) {
            return Announcement(player, Datas, data.selection)
        }
        if (data.selection === Datas.length) {
            return Main(player)
        }
    })
}

function Announcement(player, Datas, index) {
    let Data = Datas[index]
    const form = new MessageFormData()
        .title(`${Data.AnnouncementTitle}`)
        .body(`${Data.Announcement}`)
    if (player.hasTag('Admin') || player.hasTag('admin')) {
        form.button1('Delete Announcement')
    } else if (!player.hasTag('Admin') || !player.hasTag('admin')) {
        form.button1('Exit')
    }
    form.button2('Back')
    form.show(player).then((data) => {
        if (data.selection === 0) {
            if (player.hasTag('Admin') || player.hasTag('admin')) {
                system.run(() => {
                    Objective.GetObjective(player).removeParticipant(JSON.stringify(Data))
                })
            } else if (!player.hasTag('Admin') || !player.hasTag('admin')) {
                return;
            }
        }

        if (data.selection === 1) {
            AnnouncementSelection(player)
        }
    })
}


