import { ActionFormData } from "@minecraft/server-ui";
import { Admin_Main } from '../admin/main_menu';
import { AnnouncementSelection } from './announcements';
import { Menu } from './warps';
import { TPA } from './tpa_system';
import { Settings_Forms } from './settings';
import { Reports } from './reports';

import { ToggleFeature, FeatureConfig } from '../admin/toggle_features';

export function Main(player) {
    const ISTPABANNED = player.getDynamicProperty('TPABAN');
    const form = new ActionFormData().title('Community Menu');

    // Check if features are enabled and adjust buttons accordingly
    form.button(FeatureConfig.Announcements ? 'Announcements' : 'Announcements\n§r[§cDISABLED§r]', 'textures/icons/megaphone');
    form.button(FeatureConfig.Warps ? 'Warps' : 'Warps\n§r[§cDISABLED§r]', 'textures/items/ender_pearl');
    form.button(FeatureConfig.TPA ? 'TPA' : 'TPA\n§r[§cDISABLED§r]', 'textures/ui/worldsIcon');
    form.button(FeatureConfig.Settings ? 'Settings' : 'Settings\n§r[§cDISABLED§r]', 'textures/ui/icon_setting');
    form.button(FeatureConfig.Reports ? 'Reports' : 'Reports\n§r[§cDISABLED§r]', 'textures/icons/report_icon');

    if (player.hasTag('Admin') || player.hasTag('admin')) {
        form.button(FeatureConfig.AdminPanel ? 'Admin Panel' : 'Admin Panel\n§r[§cDISABLED§r]', 'textures/icons/admin');
    }

    form.show(player).then((data) => {
        if (data.selection === 0 && FeatureConfig.Announcements) {
            AnnouncementSelection(player);
        }
        if (data.selection === 1 && FeatureConfig.Warps) {
            Menu.MainMenu(player);
        }
        if (data.selection === 2 && FeatureConfig.TPA) {
            if (ISTPABANNED === false || ISTPABANNED === undefined) {
                return TPA.TPA_menu(player);
            } else if (ISTPABANNED === true) {
                TPABANNED(player);
            }
        }
        if (data.selection === 3 && FeatureConfig.Settings) {
            Settings_Forms.Main(player);
        }
        if (data.selection === 4 && FeatureConfig.Reports) {
            Reports.Main(player);
        }
        if (data.selection === 5 && FeatureConfig.AdminPanel) {
            Admin_Main(player);
        }
    });
}

function TPABANNED(player) {
    const BanReason = player.getDynamicProperty('TPABANREASON');
    const form = new ActionFormData()
        .title('ERROR: 102')
        .body(`§l§cYOU ARE BANNED FROM USING TPA\n\n§r\nA moderator has banned you from using TPA\n\n\n\nReason: ${BanReason}\n\n\n\n\n`)
        .button('Return');
    form.show(player).then((data) => {
        if (data.selection === 0) {
            Main(player);
        }
    });
}


