import { world } from '@minecraft/server'
import { ActionFormData, ModalFormData } from "@minecraft/server-ui"
import { Admin_Main } from '../admin/main_menu'

class ReportData {

    PlayerName = ""

    ReportReason = ""

    DateOfReport = ""

    constructor(ReportData) {
        if (!ReportData) return
        Object.assign(this, ReportData)
    }

}

class Objectives {

    GetObjective(player) {
        if (!world.scoreboard.getObjective(`ReportData`))
            world.scoreboard.addObjective(`ReportData`, `Data_Stored`)
        return world.scoreboard.getObjective(`ReportData`)
    }


    GetData(player) {
        let Data = []
        for (let participant of this.GetObjective(player).getParticipants()) {
            let data = new ReportData(JSON.parse(participant.displayName))
            Data.push(data)
        }
        return Data
    }

}
export const Objective = new Objectives


class Reportss {

    GetPlayerWithName(PlayerName) {
        for (let player of world.getAllPlayers()) {
            if (player.name === PlayerName) {
                return player;
            }
        }
        return undefined;
    }

    Main(player) {
        const OnlinePlayers = ['None'].concat(...world.getAllPlayers().filter(e => e.name !== player.name).map(player => player.name))
        const form = new ModalFormData()
            .title('Report A Player')
            .dropdown('Players', OnlinePlayers)
            .textField('Reason For Report', 'Example: Cheating')
        form.show(player).then((data) => {
            const D = new Date();
            const target = this.GetPlayerWithName(OnlinePlayers[data.formValues[0]])
            Objective.GetObjective(player).addScore(JSON.stringify(new ReportData({ PlayerName: target.name, ReportReason: data.formValues[1], DateOfReport: D.toString() })), 0)
            player.sendMessage(`Thank You For Reporting ${target.name}`)

        })
    }

    AdminMain(player) {
        const form = new ActionFormData()
            .title('Admin Menu')
            .button('All Reports')
        form.show(player).then((data) => {
            if (data.selection === 0)
                return this.AllReports(player)
        })
    }

    AllReports(player) {
        let Dat = Objective.GetData(player)
        const form = new ActionFormData()
        for (let i = 0; i < Dat.length; i++) {
            const Data = Dat[i]

            form.button(`${Data.PlayerName}`)
        }
        form.button('Back')
        form.show(player).then((data) => {
            if (data.selection < Dat.length) {
                return this.ReportInfo(player, Dat, data.selection)
            }
            if (data.selection < Dat.length + 1) {
                return Admin_Main(player)
            }
        })
    }

    ReportInfo(player, Dat, index) {
        let Data = Dat[index]
        const form = new ActionFormData()
            .body(`Player Name: ${Data.PlayerName}\n\nReason For Report: ${Data.ReportReason}\n\nDate: ${Data.DateOfReport}\n\n`)
            .button('Actions')
            .button('Back')
            .button('Delete Report')
        form.show(player).then((data) => {
            if (data.selection === 1) {
                return this.AdminMain(player)
            }
            if (data.selection === 2) {
                Objective.GetObjective(player).removeParticipant(JSON.stringify(Data))
            }
        })
    }

    ActionsMenu(player) {
        const form = new ActionFormData()
            .body('What Kind Of Action Would You Like To Take')
        //put what actions you want here
        form.show(player).then((data) => {

        })
    }

}
export const Reports = new Reportss


