import { world } from '@minecraft/server';

world.beforeEvents.chatSend.subscribe(event => {
    const { message, sender: player } = event;

    // Check if the command is for the lag zapper
    if (message.startsWith("!lagclear ")) {
        // Check if the player is an admin
        if (player.hasTag('Admin') || player.hasTag('admin')) {
            const args = message.trim().split(" ");
            if (args.length !== 2) {
                player.sendMessage("§cUsage: !lagclear [timeuntil every lag zap]");
                event.cancel = true;
                return;
            }

            const time = parseInt(args[1]);
            if (isNaN(time) || time <= 0) {
                player.sendMessage("§cPlease provide a valid time in seconds.");
                event.cancel = true;
                return;
            }

            // Notify admin and set a timeout to clear items
            player.sendMessage(`§aLag zapper will clear all items in ${time} seconds...`);
            setTimeout(() => {
                // Clear all items from the world
                const entities = world.getAllEntities();
                entities.forEach(entity => {
                    if (entity.isItemEntity) {
                        entity.kill(); // Remove the item entity
                    }
                });
                world.sendMessage("§cAll items have been cleared from the world!");
            }, time * 1000); // Convert seconds to milliseconds
        } else {
            player.sendMessage("§cYou do not have permission to use this command.");
            event.cancel = true;
        }
    }
});
