import { world, system } from '@minecraft/server';

world.beforeEvents.chatSend.subscribe(event => {
    const { message, sender: player } = event;

    // Check if the command is for the lag zapper
    if (message.startsWith("!lagclear ")) {
        // Check if the player is an admin
        if (player.hasTag('Admin') || player.hasTag('admin')) {
            const args = message.trim().split(" ");
            if (args.length !== 2) {
                player.sendMessage("§cUsage: !lagclear [timeuntil every lag zap]");
                event.cancel = true;
                return;
            }

            const time = parseInt(args[1]);
            if (isNaN(time) || time <= 0) {
                player.sendMessage("§cPlease provide a valid time in seconds.");
                event.cancel = true;
                return;
            }

            // Notify admin about the lag zapper command
            player.sendMessage(`§aLag zapper will clear all items in ${time} seconds...`);

            // Countdown messages and clearing items
            for (let i = time; i > 0; i--) {
                system.runTimeout(() => {
                    if (i === 1) {
                        player.sendMessage(`§cClearing items now!`);
                        // Clear items using command
                        world.runCommandAsync('kill @e[type=item]');
                    } else {
                        player.sendMessage(`§e${i - 1}...`);
                    }
                }, (time - i) * 1000); // Schedule countdown messages
            }

            // Cancel the original event message
            event.cancel = true;
        } else {
            player.sendMessage("§cYou do not have permission to use this command.");
            event.cancel = true;
        }
    }
});
